import Actor
from pymunk.vec2d import vec2d
from Sound import gSound


class BallSpawnerActor( Actor.Actor ):
    def __init__(self, id, type, physics, actormanager):
        Actor.Actor.__init__( self, id, type )
        self.physics = physics
        self.actorManager = actormanager
        
        self.level = self.actorManager.gameState.level
        
        self.time = -3.0
        self.spawnTime = 1.0
        
        self.lastHitActor = None
        
        
    
    def update(self, dt):
        Actor.Actor.update(self, dt)
        
        
        if not self.actorManager.gameState.level.ballsLeftToSpawn():
            return
        
        self.time += dt
        if self.time > self.spawnTime:
            self.time -= self.spawnTime
            
            offset = vec2d( 30, -30 )
            ball = self.actorManager.createActor("ball", self.getPos()+offset, size=50)
            self.physics.applyImpulse( ball.body, vec2d(1,-1) * 100 )
            self.actorManager.gameState.level.ballSpawned()
            
            gSound.playSound( self, "pipe" ) 
             
            