import random
import pygame

from Graphics import Graphics
from Physics import Physics
import Sound

from ActorManager import ActorManager
from GameStateManager import GameStateManager
from MainGameState import MainGameState
from MenuState import MenuState
from LoadingState import LoadingState
from IntroState import IntroState

from pymunk.vec2d import vec2d

class Game:
    def __init__(self):
        #global gSound
        self.graphics = Graphics()
        
        #self.sound = Sound.Sound()
        #gSound = self.sound
        #Sound.gSound.playSound(self, "metalbounce2") 
        
        self.physics = Physics()
        self.gameStateManager = GameStateManager( self.physics )
            
        state = MainGameState( self.gameStateManager, self.graphics, self.physics )
        self.gameStateManager.pushState( state )
        
        #state = MenuState( self.gameStateManager, self.graphics )
        #state = LoadingState( self.gameStateManager, self.graphics )
        #self.gameStateManager.pushState( state )
        state = IntroState( self.gameStateManager, self.graphics )
        self.gameStateManager.pushState( state )
        self.shouldQuit = False
        self.graphics.main_gui.disable()
        
        Sound.gSound.playSound(self, "Ecologia", True)
        
    def update(self, dt):
        self.gameStateManager.update(dt)

        if self.gameStateManager.states == []:
            self.shouldQuit = True
    
    def render(self):
        self.graphics.update()
        pygame.display.flip()
        
    
    
