import random

from Graphics import Graphics
from Physics import Physics
from ActorManager import ActorManager
from pymunk.vec2d import vec2d

class GameStateManager:
    def __init__(self, physics):
        self.states = []
        self.physics = physics
        
        self.slowmo = False
    
    def pushState(self, state):
        self.states.append( state )
            
    def popState(self):
        state = self.states.pop()
        state.pop()
        return state
    
    def popAllStates(self):
        self.states = []
        
    def update(self, dt):
        #self.physics.update( dt )        
        #self.actorManager.update()
        #print "GSM: update"
        #print self.states
        
        if self.slowmo: 
            dt *= 0.2
        for i in range(len(self.states)-1, -1, -1):
            state = self.states[i]
            state.update(dt)
            if state.blockUpdate:
                break
    """
    def draw(self, dt):
        statesToDraw = []
        for i in range(len(self.states)-1, -1, -1):
            statesToDraw.append(self.states[i])
            if self.states[i].blockDraw:
                break
        statesToDraw.reverse()
        for state in statesToDraw:           
            state.draw(dt)    
    """    
        