import Actor
from pymunk.vec2d import vec2d
from Sound import gSound

class GravityActor( Actor.Actor ):
    
    #yes, a static variable
    lastHitActor = None
    
    def __init__(self, id, type, physics, actormanager):
        Actor.Actor.__init__( self, id, type )
        self.physics = physics
        self.actorManager = actormanager
        
        
    
    def update(self, dt):
        Actor.Actor.update(self, dt)      

    def onCollide( self, actor2, contact_points, num_contact_points, data):
        
        contact = contact_points.contents.p.x, contact_points.contents.p.y

        self.physics.applyImpulse( actor2.body, contact_points.contents.n * -300 )
        n = contact_points.contents.n
        if self.type == "gravity1":
            self.physics.setGravity( -n )
        else:
            self.physics.setGravity( n )
        #self.actorManager.graphics.world.camera.angle = n.get_angle() - 90
        #self.lastHitActor = actor2
        self.collidedLastFrame = True 
        
        gSound.playSound( self, "gravity" )
        
        self.animFactor = 10.0 
    
    