import random
import pygame
from pygame.locals import *
from Graphics import Graphics
from GameStateManager import GameStateManager
from pymunk.vec2d import vec2d

import qgl

class HelpState:
    def __init__(self, gameStateManager, graphics):
        self.gameStateManager = gameStateManager
        self.graphics = graphics
        self.blockUpdate = True

        self.gui = qgl.scene.Group()
        self.graphics.gui.add(self.gui)
        texture = self.graphics.createTexture("help")
        quad = self.graphics.createQuad((1024, 1024))
        bg = qgl.scene.Group(texture, quad)
        self.gui.add(bg)
        #self.gui.translate = -300, 0, 0
        #text.size = 1000
        self.graphics.gui.accept(self.graphics.compiler)

        
    def update(self, dt):
        for event in pygame.event.get():
            if event.type is QUIT:
                self.gameStateManager.popAllStates()
                return
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                self.gameStateManager.popState()
                return
            elif event.type == KEYDOWN and event.key == K_h:
                self.gameStateManager.popState()
                return
            elif event.type == MOUSEBUTTONDOWN:
                self.gameStateManager.popState()
                return

    def pop(self):
        self.graphics.gui.remove(self.gui)
        
        