import random
import pygame
from pygame.locals import *
from Graphics import Graphics
from GameStateManager import GameStateManager
from MenuState import MenuState
from pymunk.vec2d import vec2d

import qgl

class IntroState:
    def __init__(self, gameStateManager, graphics):
        self.gameStateManager = gameStateManager
        self.graphics = graphics
        self.blockUpdate = True

        self.gui = qgl.scene.Group()
        self.graphics.gui.add(self.gui)
        
        ### BG
        texture = self.graphics.createTexture("grey")
        quad = self.graphics.createQuad(self.graphics.screenSize)
        bg = qgl.scene.Group(texture, quad)
        self.gui.add(bg)
        
        ### Loading text
        self.text = self.graphics.createText("Bouncy", "lousy")
        self.text.size = 1000
        g = qgl.scene.Group( self.text )
        g.translate = -300, 100, 0
        self.gui.add(g)
        
        text1 = self.graphics.createText("By Srekel and viblo", "lousy")
        text1.size = 600
        g = qgl.scene.Group( text1 )
        g.translate = -300, -100, 0
        self.gui.add(g)
        
        text2 = self.graphics.createText("For PyWeek 5. September 2007.", "lousy")
        text2.size = 500
        g = qgl.scene.Group( text2 )
        g.translate = -300, -150, 0
        self.gui.add(g)
        
        ### Other text
        text = self.graphics.createText("Press any button to continue...", "lousy")
        text.size = 300
        g = qgl.scene.Group( text )
        g.translate = -350, -300, 0
        self.gui.add(g)
        
        self.graphics.gui.accept(self.graphics.compiler)
        self.graphics.main_gui.disable()
        self.t = 0
        
    def update(self, dt):
        for event in pygame.event.get():
            if event.type is QUIT:
                self.gameStateManager.popAllStates()
                return
            elif event.type == KEYDOWN:
                self.gameStateManager.popState()
                self.gameStateManager.pushState( MenuState( self.gameStateManager, self.graphics ) )
                return
            elif event.type == MOUSEBUTTONDOWN:
                self.gameStateManager.popState()
                self.gameStateManager.pushState( MenuState( self.gameStateManager, self.graphics ) )
                return
        return
        self.t += dt
        if self.t > 0.3:
            self.t = 0
            if len(self.text.text) > 20:
                self.text.text = "Loading"
            else:
                self.text.text += "."
        
        
    def pop(self):
        self.graphics.gui.remove(self.gui)
        
        