import random

from pymunk.vec2d import vec2d

class Level:
    def __init__(self, name = "level1", total_balls = 1000, ball_goal = 20, objects = None, next_level = None):
        self.name = name 
        self.balls_left = total_balls
        self.goal = ball_goal
        
        if next_level is None:
            for char in self.name:
                if char in "12345678":
                    next_level = "level" + str( (int(char) + 1) )

        self.next_level = next_level
        if objects == None:
            self.objects_left = {"box":100, "gravity1":20, "gravity2":20, "stretch":40}
        else:
            self.objects_left = objects   
            
        ### Hard coded :)    
        if name == "level1":
            self.objects_left = {"box":0, "gravity1":0, "gravity2":0, "stretch":1}
            self.balls_left = 50
            self.goal = 10
        elif name == "level2":
            self.objects_left = {"box":4, "gravity1":0, "gravity2":0, "stretch":0}
            self.balls_left = 25
            self.goal = 10
        elif name == "level3":
            self.objects_left = {"box":4, "gravity1":0, "gravity2":0, "stretch":1}
            self.balls_left = 25
            self.goal = 20
        elif name == "level4":
            self.objects_left = {"box":0, "gravity1":1, "gravity2":0, "stretch":0}
            self.balls_left = 75
            self.goal = 15    
        elif name == "level5":
            self.objects_left = {"box":0, "gravity1":0, "gravity2":1, "stretch":0}
            self.balls_left = 50
            self.goal = 15 
        elif name == "level6":
            self.objects_left = {"box":10, "gravity1":4, "gravity2":4, "stretch":10}
            self.balls_left = 30
            self.goal = 15 
        elif name == "level7":
            self.objects_left = {"box":0, "gravity1":1, "gravity2":0, "stretch":0}
            self.balls_left = 10
            self.goal = 5
        elif name == "level8":
            self.objects_left = {"box":1, "gravity1":0, "gravity2":1, "stretch":0}
            self.balls_left = 10
            self.goal = 5
        elif name == "level9":
            self.objects_left = {"box":0, "gravity1":2, "gravity2":0, "stretch":1}
            self.balls_left = 10
            self.goal = 2   
        elif name == "extra":
            self.objects_left = {"box":99, "gravity1":99, "gravity2":99, "stretch":99}
            self.balls_left = 100
            self.goal = 50   
    def ballSpawned(self):
        self.balls_left -= 1
        #print "ballSpawned1     - balls_left:", self.balls_left
        
    def ballsLeftToSpawn( self ):
        return self.balls_left > 0
        
        
    def addFinishedBall(self):
        self.goal -= 1
        if self.goal < 0:
            self.goal = 0
        #print "addFinishedBall - goal:", self.goal
        
    def isComplete( self ):
        return self.goal == 0
        