import random
import pygame
from pygame.locals import *
from Graphics import Graphics
from GameStateManager import GameStateManager
from pymunk.vec2d import vec2d

import qgl

class PauseState:
    def __init__(self, gameStateManager, graphics):
        self.gameStateManager = gameStateManager
        self.graphics = graphics
        self.blockUpdate = True

        self.gui = qgl.scene.Group()
        self.graphics.gui.add(self.gui)
        text = self.graphics.createText("Paused!", "lousy")
        self.gui.add(text)
        text.size = 500
        self.graphics.gui.accept(self.graphics.compiler)

        
    def update(self, dt):
        for event in pygame.event.get():
            if event.type is QUIT:
                self.gameStateManager.popAllStates()
                return
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                self.gameStateManager.popState()
                return
            elif event.type == KEYDOWN and event.key == K_PAUSE:
                self.gameStateManager.popState()
                return

    def pop(self):
        self.graphics.gui.remove(self.gui)
        
        