import Actor
from pymunk.vec2d import vec2d

class StretchActor( Actor.Actor ):
    def __init__(self, id, type, physics):
        Actor.Actor.__init__( self, id, type )
        self.physics = physics
        
        self.lastHitActor = None
        self.quad = None
        
        # for saving
        self.lastmousepos = None
        
    def updateStretch(self, mouse_pos, g):
        
        self.lastmousepos = mouse_pos
        
        t = 0.05
        x,y,z = self.node.translate
        node_pos = vec2d(x,y)
        
        d = mouse_pos - node_pos
        dist = d.length
        n = d.perpendicular_normal()
        v1 = n * -10
        v2 = n * 10
        v3 = d + n * 10
        v4 = d + n * -10
        self.quad.vertices = v1,v2,v3,v4
        self.quad.texture_coords = (0.0,0.0),(0.0,1.0),(1.0*dist*t,1.0),(1.0*dist*t,0.0)
        self.node.accept( g.getCompiler() )

    def update(self, dt):
        Actor.Actor.update(self, dt)

        
    def save(self):
        d = Actor.Actor.save(self) 
        d["vertices"] = self.quad.vertices
        d["texture_coords"] = self.quad.texture_coords
        return d
    