import random
import pygame
from pygame.locals import *
from Graphics import Graphics
from GameStateManager import GameStateManager
from MenuState import MenuState
from pymunk.vec2d import vec2d
from Sound import gSound
import qgl

class WinState:
    def __init__(self, gameStateManager, graphics, level):
        self.gameStateManager = gameStateManager
        self.graphics = graphics
        self.level = level
        
        self.blockUpdate = True

        texts = []
        if self.level.next_level is not None:
            texts.append( "You solved " + self.level.name + "!" )
            texts.append( "Press any key to proceed to " + self.level.next_level  )
        else:
            texts.append( "CONGRATULATIONS!!" )
            texts.append( "You solved all levels!" )
            #texts.append( "" )
            #texts.append( "Press any key to proceed to the main menu" )
        
        texture = self.graphics.createTexture("win_bg")
        quad = self.graphics.createQuad((800, 600))
        bg = qgl.scene.Group(texture, quad)
        self.gui = qgl.scene.Group(bg)
        self.graphics.gui.add(self.gui)
        
        y = 10
        for name in texts:
            text = self.graphics.createText(name, "lousy")
            text.size = 550
            c = qgl.scene.state.Color((0.0,0 ,0.0,1.0))
            g = qgl.scene.Group( c, text )
            g.color = c
            g.selectable = True
            g.name = name
            g.type = "menu"
            g.translate = (-320, y, 0)
            g.selectable = True
            self.gui.add( g )
            y -= 80

#        self.gui = qgl.scene.Group()
#        self.t
#        self.graphics.gui.add(self.gui)
#        text = self.graphics.createText("You solved " + self.level.name + "!", "lousy")
#        self.gui.add(text)
#        text = self.graphics.createText("Press any key to proceed!", "lousy")
#        self.gui.add(text)
#        self.gui.translate = -300, 0, 0
#        text.size = 100
        self.graphics.gui.accept(self.graphics.compiler)
        gSound.playSound(self, "applause")
        
    def update(self, dt):
        for event in pygame.event.get():
            if event.type is QUIT:
                self.gameStateManager.popAllStates()
                return
            
            if event.type == KEYDOWN or event.type == MOUSEBUTTONDOWN:
                self.gameStateManager.popState()
                
                if self.level.next_level is not None:
                    self.gameStateManager.states[-1].loadLevel( self.level.next_level )
                else:
                    state = MenuState( self.gameStateManager, self.graphics )
                    self.graphics.main_gui.disable()
                    self.gameStateManager.pushState( state )
                    
    def pop(self):
        self.graphics.gui.remove(self.gui)
        
        