#! /usr/bin/env python

import sys
import os


try:
    __file__
except NameError:
    pass
else:
    libdir = os.path.abspath(os.path.join(os.path.dirname(__file__), 'lib'))
    sys.path.insert(0, libdir)

import main

debug = 0
if debug == 1:
    import hotshot, hotshot.stats
    prof = hotshot.Profile("main.main")
    prof.runcall(main.main)
    prof.close()
    stats = hotshot.stats.load("main.main")
    stats.strip_dirs()
    stats.sort_stats('time', 'calls')
    stats.print_stats(20)
elif debug == 2:
    import cProfile, pstats
    cProfile.run("main.main()", "main")
    stats = pstats.Stats( "main" )
    stats.strip_dirs()
    stats.sort_stats('time', 'calls')
    stats.print_stats(30)
else:
    main.main()
